#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>

int main( int argc, char **argv )
{
	char *bin_file,*hex_file;
	int output = 1;
	if ( (argc != 3) && (argc != 2))
	{
		printf( "./bin2hex [bin] [hex_txt]\n" );
		printf( "./bin2hex [bin] - ... for binary output \n" );
		exit( 0 );
	}
	if (argc == 2) output = 0;
	bin_file = argv[1];
	hex_file = argv[2];
	
	char c;
	int fsize,i;
	struct stat fbuf;	
	FILE *ifid, *ofid;
	ifid = fopen( bin_file , "r" );
	fstat( fileno(ifid) , &fbuf);
	fsize = fbuf.st_size;
	if (output) ofid = fopen( hex_file , "w" );
	for (i=0;i<fsize;i++)
	{
		c = fgetc( ifid );
		if (output) fprintf(ofid,"\\x%x",c&0xff);
		else printf("\\x%x",c&0xff);	
	}
	if (!output) printf("\n");
	fclose( ifid );
	if (output) fclose( ofid );
	
	return 0;
}
